All of lore.kernel.org
 help / color / mirror / Atom feed
From: Omar Sandoval <osandov@osandov.com>
To: linux-btrfs@vger.kernel.org
Cc: kernel-team@fb.com
Subject: [PATCH v13 10/10] btrfs-progs: receive: add tests for basic encoded_write send/receive
Date: Thu, 10 Feb 2022 11:10:17 -0800	[thread overview]
Message-ID: <f2c81c98036da9e68d2ef96df36bcc8d74100316.1644520114.git.osandov@fb.com> (raw)
In-Reply-To: <cover.1644519257.git.osandov@fb.com>

From: Boris Burkov <boris@bur.io>

Adapt the existing send/receive tests by passing '-o compress-force' to
the mount commands in a new test. After writing a few files in the
various compression formats, send/receive them with and without
--force-decompress to test both the encoded_write path and the fallback
to decode+write.

Signed-off-by: Boris Burkov <boris@bur.io>
---
 .../052-receive-write-encoded/test.sh         | 114 ++++++++++++++++++
 1 file changed, 114 insertions(+)
 create mode 100755 tests/misc-tests/052-receive-write-encoded/test.sh

diff --git a/tests/misc-tests/052-receive-write-encoded/test.sh b/tests/misc-tests/052-receive-write-encoded/test.sh
new file mode 100755
index 00000000..47330281
--- /dev/null
+++ b/tests/misc-tests/052-receive-write-encoded/test.sh
@@ -0,0 +1,114 @@
+#!/bin/bash
+#
+# test that we can send and receive encoded writes for three modes of
+# transparent compression: zlib, lzo, and zstd.
+
+source "$TEST_TOP/common"
+
+check_prereq mkfs.btrfs
+check_prereq btrfs
+
+setup_root_helper
+prepare_test_dev
+
+here=`pwd`
+
+# assumes the filesystem exists, and does mount, write, snapshot, send, unmount
+# for the specified encoding option
+send_one() {
+	local str
+	local subv
+	local snap
+
+	algorithm="$1"
+	shift
+	str="$1"
+	shift
+
+	subv="subv-$algorithm"
+	snap="snap-$algorithm"
+
+	run_check_mount_test_dev "-o" "compress-force=$algorithm"
+	cd "$TEST_MNT" || _fail "cannot chdir to TEST_MNT"
+
+	run_check $SUDO_HELPER "$TOP/btrfs" subvolume create "$subv"
+	run_check $SUDO_HELPER dd if=/dev/zero of="$subv/file1" bs=1M count=1
+	run_check $SUDO_HELPER dd if=/dev/zero of="$subv/file2" bs=500K count=1
+	run_check $SUDO_HELPER "$TOP/btrfs" subvolume snapshot -r "$subv" "$snap"
+	run_check $SUDO_HELPER "$TOP/btrfs" send -f "$str" "$snap" "$@"
+
+	cd "$here" || _fail "cannot chdir back to test directory"
+	run_check_umount_test_dev
+}
+
+receive_one() {
+	local str
+	str="$1"
+	shift
+
+	run_check_mkfs_test_dev
+	run_check_mount_test_dev
+	run_check $SUDO_HELPER "$TOP/btrfs" receive "$@" -v -f "$str" "$TEST_MNT"
+	run_check_umount_test_dev
+	run_check rm -f -- "$str"
+}
+
+test_one_write_encoded() {
+	local str
+	local algorithm
+	algorithm="$1"
+	shift
+	str="$here/stream-$algorithm.stream"
+
+	run_check_mkfs_test_dev
+	send_one "$algorithm" "$str" --compressed-data
+	receive_one "$str" "$@"
+}
+
+test_one_stream_v1() {
+	local str
+	local algorithm
+	algorithm="$1"
+	shift
+	str="$here/stream-$algorithm.stream"
+
+	run_check_mkfs_test_dev
+	send_one "$algorithm" "$str" --proto 1
+	receive_one "$str" "$@"
+}
+
+test_mix_write_encoded() {
+	local strzlib
+	local strlzo
+	local strzstd
+	strzlib="$here/stream-zlib.stream"
+	strlzo="$here/stream-lzo.stream"
+	strzstd="$here/stream-zstd.stream"
+
+	run_check_mkfs_test_dev
+
+	send_one "zlib" "$strzlib" --compressed-data
+	send_one "lzo" "$strlzo" --compressed-data
+	send_one "zstd" "$strzstd" --compressed-data
+
+	receive_one "$strzlib"
+	receive_one "$strlzo"
+	receive_one "$strzstd"
+}
+
+test_one_write_encoded "zlib"
+test_one_write_encoded "lzo"
+test_one_write_encoded "zstd"
+
+# with decompression forced
+test_one_write_encoded "zlib" "--force-decompress"
+test_one_write_encoded "lzo" "--force-decompress"
+test_one_write_encoded "zstd" "--force-decompress"
+
+# send stream v1
+test_one_stream_v1 "zlib"
+test_one_stream_v1 "lzo"
+test_one_stream_v1 "zstd"
+
+# files use a mix of compression algorithms
+test_mix_write_encoded
-- 
2.35.1


  parent reply	other threads:[~2022-02-10 19:10 UTC|newest]

Thread overview: 34+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2022-02-10 19:09 [PATCH v13 00/17] btrfs: add ioctls and send/receive support for reading/writing compressed data Omar Sandoval
2022-02-10 19:09 ` [PATCH v13 01/17] fs: export rw_verify_area() Omar Sandoval
2022-02-10 19:09 ` [PATCH v13 02/17] fs: export variant of generic_write_checks without iov_iter Omar Sandoval
2022-02-10 19:09 ` [PATCH v13 03/17] btrfs: don't advance offset for compressed bios in btrfs_csum_one_bio() Omar Sandoval
2022-02-10 19:09 ` [PATCH v13 04/17] btrfs: add ram_bytes and offset to btrfs_ordered_extent Omar Sandoval
2022-02-11 17:12   ` David Sterba
2022-02-10 19:09 ` [PATCH v13 05/17] btrfs: support different disk extent size for delalloc Omar Sandoval
2022-02-10 19:09 ` [PATCH v13 06/17] btrfs: clean up cow_file_range_inline() Omar Sandoval
2022-02-10 19:09 ` [PATCH v13 07/17] btrfs: optionally extend i_size in cow_file_range_inline() Omar Sandoval
2022-02-10 19:09 ` [PATCH v13 08/17] btrfs: add definitions + documentation for encoded I/O ioctls Omar Sandoval
2022-02-11 18:17   ` David Sterba
2022-02-14 19:19     ` Omar Sandoval
2022-02-18 15:18       ` David Sterba
2022-02-10 19:09 ` [PATCH v13 09/17] btrfs: add BTRFS_IOC_ENCODED_READ Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 10/17] btrfs: add BTRFS_IOC_ENCODED_WRITE Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 11/17] btrfs: send: remove unused send_ctx::{total,cmd}_send_size Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 12/17] btrfs: send: explicitly number commands and attributes Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 13/17] btrfs: add send stream v2 definitions Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 14/17] btrfs: send: write larger chunks when using stream v2 Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 15/17] btrfs: send: allocate send buffer with alloc_page() and vmap() for v2 Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 16/17] btrfs: send: send compressed extents with encoded writes Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 17/17] btrfs: send: enable support for stream v2 and compressed writes Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 01/10] btrfs-progs: receive: support v2 send stream larger tlv_len Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 02/10] btrfs-progs: receive: dynamically allocate sctx->read_buf Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 03/10] btrfs-progs: receive: support v2 send stream DATA tlv format Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 04/10] btrfs-progs: receive: add send stream v2 cmds and attrs to send.h Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 05/10] btrfs-progs: receive: process encoded_write commands Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 06/10] btrfs-progs: receive: encoded_write fallback to explicit decode and write Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 07/10] btrfs-progs: receive: process fallocate commands Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 08/10] btrfs-progs: receive: process setflags ioctl commands Omar Sandoval
2022-02-10 19:10 ` [PATCH v13 09/10] btrfs-progs: send: stream v2 ioctl flags Omar Sandoval
2022-02-10 19:15   ` Omar Sandoval
2022-02-10 19:10 ` Omar Sandoval [this message]
2022-02-18 15:41 ` [PATCH v13 00/17] btrfs: add ioctls and send/receive support for reading/writing compressed data David Sterba

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=f2c81c98036da9e68d2ef96df36bcc8d74100316.1644520114.git.osandov@fb.com \
    --to=osandov@osandov.com \
    --cc=kernel-team@fb.com \
    --cc=linux-btrfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.